dnl CW_DO_OPTIONS
dnl Chose reasonable default values for WARNOPTS, DEBUGOPTS and EXTRAOPTS
AC_DEFUN([CW_DO_OPTIONS], [dnl
dnl Choose warning options to use
if test "$USE_MAINTAINER_MODE" = yes; then
AC_EGREP_CPP(Winline-broken,
[#if __GNUC__ < 3
Winline-broken
#endif
],
WARNOPTS="-Wall -Woverloaded-virtual -Wundef -Wpointer-arith -Wwrite-strings -Werror",
WARNOPTS="-Wall -Woverloaded-virtual -Wundef -Wpointer-arith -Wwrite-strings -Werror -Winline")
else
WARNOPTS=
fi
AC_SUBST(WARNOPTS)

dnl Stop automake from adding the `-I. -I. -I.' nonsense
AC_SUBST(DEFS)

dnl Find out which debugging options we need
AC_CANONICAL_HOST
case "$host" in
  *freebsd*) DEBUGOPTS=-ggdb ;; dnl FreeBSD needs -ggdb to include sourcefile:linenumber info in its object files.
  *) DEBUGOPTS=-g ;;
esac
AC_SUBST(DEBUGOPTS)

AC_ARG_ENABLE(optimization,
    AC_HELP_STRING([--enable-optimization], [enable optimization of libecc @<:@default=!maintainermode@:>@.]),
    libecc_config_optimization=$enableval)

dnl Other options
EXTRAOPTS=""
if test "$USE_MAINTAINER_MODE" = yes; then
  if test x"$libecc_config_optimization" = x"yes"; then
    EXTRAOPTS="-O3"
  fi
elif test x"$libecc_config_optimization" != x"no"; then
  EXTRAOPTS="-O3"
fi
AC_SUBST(EXTRAOPTS)

dnl Test options
TESTOPTS=""
AC_SUBST(TESTOPTS)
])
